import java.awt.Point;
import java.io.*;


/** An InputSpec contains the puzzle specification read from standard input. */

public class InputSpec
{
    /** Create an InputSpec by reading the specification from standard in. */

    public InputSpec() throws IOException
    {
        NumberSource nums = new NumberSource(System.in);
        
        // read input spec

        boxShape = new Shape(nums);
        
        int numshapes = nums.next();
        
        goalIndex = numshapes;
        
        ++numshapes;                // for the goal piece shape     
        
        pieceShapes = new Shape[numshapes];
        
        // Read the free shapes and the goal shape
        
        for (int i = 0; i < numshapes; ++i)
            pieceShapes[i] = new Shape(nums);

        // read the goal location
        
        goalLocation = new Point();
        goalLocation.x = nums.next();
        goalLocation.y = nums.next();
    }


    /** the table of valid piece shapes */
    
    Shape pieceShapes[];

    
    /** index of the goal piece (= shapes.length - 1)   */
    
    int goalIndex;
    
    
    /** goal location */ 
    
    Point goalLocation;

    
    /** box shape */ 
    
    Shape boxShape;
};

