import java.io.*;


/** A NumberSource is an object that returns successive integers parsed
    from an InputStream.  It ignores everything else in the stream. */

public class NumberSource
{
    StreamTokenizer tokenizer;
    
    public NumberSource(InputStream in)
    {
        // make the tokenizer
        
        tokenizer = new StreamTokenizer(in);
        
        // ignore everything but integers
        
        tokenizer.whitespaceChars(0, '0' - 1);
        tokenizer.whitespaceChars('9' + 1, 255);
    }
    
    public int next() throws IOException
    {
        tokenizer.nextToken();
        
        if (tokenizer.ttype != StreamTokenizer.TT_NUMBER)
            throw new IOException("out of data");
            
        return (int) tokenizer.nval;
    }
}
