/** A PieceList is a linked list of Pieces. */

public class PieceList
{
    public Piece piece;
    public PieceList next;


    /** Make a new piece list node. */

    public PieceList(Piece p, PieceList pl)
    {
        piece = p;
        next = pl;
    }


    /** Make a copy of an existing piece list. */

    public PieceList(PieceList pl)
    {
        piece = new Piece(pl.piece);
        next = pl.next != null ? new PieceList(pl.next) : null;
    }
    
                        
    /** Print a PieceList.  The list is printed in order; this matches the order
        piece numbers are assigned when printing solutions. */

    public void print()
    {
        piece.print();

        if (next != null)
            next.print();   
    }
    
    
    /** Find the pieceNumth piece in the list. */

    public Piece index(int pieceNum)
    {
        return pieceNum > 0 ? next.index(pieceNum - 1) : piece;
    }
}
