import java.io.IOException;

/** A Shape is a 2-dimensional bit vector defining the unit squares occupied by a piece
    or a box. */

public class Shape
{
    boolean     bits[][];           // the squares this piece occupies
    
    
    /** Read a Shape specification from a NumberSource. */
    
    public Shape(NumberSource nums) throws IOException
    {
        int w = nums.next();
        int h = nums.next();
        
        bits = new boolean[w][h];
        
        for (int j = 0; j < h; ++j)
            for (int i = 0; i < w; ++i)
                bits[i][j] = nums.next() == 0 ? false : true;
    }
    
    /** What is this shape's width? */
    
    public int width()
    {
        return bits.length;
    }
    

    /** What is this shape's height? */
    
    public int height()
    {
        return bits[0].length;
    }
    
    
    /** Does this shape occupy square x, y? */
    
    public boolean occupies(int x, int y)
    {
        if (x < 0 || y < 0 || x >= width() || y >= height())
            return false;
            
        return bits[x][y];
    }
    
    
    public void print()
    {
        for (int j = 0; j < height(); ++j)
        {
            for (int i = 0; i < width(); ++i)
                System.out.print(bits[i][j] ? "* " : ". ");
                
            System.out.println();
        }       
    }
}
